import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.*;



public class PannCompte extends JPanel
{
	PbReseau Probleme;
	int Taille;
	int TailleMax;
	int SiteEnCours;
	
	JLabel[] Compte;
	JLabel[] Frequence;
	JButton[] Page;
	JLabel Titre1;
	JLabel Titre2;
	JLabel Titre3;
	
	NumberFormat Nformat = NumberFormat.getNumberInstance();

	public PannCompte (PbReseau cProbleme)
	{
		Nformat.setMaximumFractionDigits(0);
		
		Probleme = cProbleme;
		Taille = Probleme.TailleEnCours;
		TailleMax = Probleme.TailleMax;
		SiteEnCours = Probleme.SiteEnCours;
		
		GridLayout Disposition = new GridLayout(Probleme.TailleMax + 1 ,3);
		this.setLayout(Disposition);

		
		Compte = new JLabel[TailleMax];
		Frequence= new JLabel[TailleMax];
		Page = new JButton[TailleMax];
		
		Titre1 = new JLabel("Page",	JLabel.CENTER);
		Titre2 = new JLabel("Nb",	JLabel.CENTER);
		Titre3 = new JLabel("%",	JLabel.CENTER);
		
		this.add(Titre1);
		this.add(Titre2);
		this.add(Titre3);
		
		
		
		for (int i = 0 ; i < TailleMax ; i++)
		{
			Page[i] = new JButton(Integer.toString(i+1));
			Page[i].addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					
					String Temp =  event.getActionCommand();
					int TT = Integer.parseInt(Temp) - 1;
					//System.out.println("ActionCommand = " + Temp );
					int i=0;
					while(TT != i && i< Probleme.TailleMax )
					{
						//System.out.println(Temp + i + (Temp != Integer.toString(i)));
						i++;
					}
					//System.out.println(i);
					Probleme.SiteEnCours = i;
					Probleme.Reinitialiser(Probleme.NumPb, Probleme.ToutePage);
				}
				 
			});
			this.add(Page[i]);
			Compte[i] = new JLabel("blop",SwingConstants.RIGHT);
			this.add(Compte[i]);
			Frequence[i] = new JLabel("blop",SwingConstants.RIGHT);
			this.add(Frequence[i]);
		}
		ReinitialiserCompte();
		//this.setVisible(true);
	}
	
	
	public void ReinitialiserCompte()
	{
		SiteEnCours = Probleme.SiteEnCours;
		//System.out.println("Site en cours : " + Probleme.SiteEnCours);
		Taille = Probleme.TailleEnCours;
		for (int i = 0 ; i < Probleme.TailleMax; i++)
		{
			Page[i].setVisible(i<Taille);
			Compte[i].setVisible(i<Taille);
			Frequence[i].setVisible(i<Taille);
		}
			
			
			
		for (int i = 0 ; i < Taille ; i++)
		{
			Compte[i].setText(Integer.toString(Kronecker(i,SiteEnCours)));
		}
		CalculerFrequences();
	}
	
	public void CalculerFrequences()
	{
		for (int i = 0 ; i < Taille ; i++)
		{
			double c = Double.parseDouble(Compte[i].getText());
			Frequence[i].setText(Nformat.format(100*c/(Probleme.nbIteration+1)));	
		}
	}
	
	public void Ajuster(int nouveauSite)
	{
	
	Compte[nouveauSite].setText(Integer.toString(  Integer.parseInt(Compte[nouveauSite].getText())+1 ));

	CalculerFrequences();
	}
	
	
	public int Kronecker(int j, int k)
	{
		if (j == k)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}



}
