import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;


public class PannDessin extends JPanel
{
	int NumPb;
	double[][] courPoints;
	double[] courVecteur;
	int Taille;
	double Rayon;
	double Fleche = 5;
	double Pos = 5;
	PbReseau Probleme;

	
	double Largeur;
	double Hauteur;
	
	public PannDessin (PbReseau Pb)
	{
		Probleme = Pb;

		Largeur = 400;
		Hauteur = 400;
		Rayon = 20;
		
		Rafraichir();
	}

	public void Rafraichir()
	{
		NumPb = Probleme.NumPb;
		courPoints = (Probleme.Points)[NumPb];
		
		if (Probleme.ModeProba)
		{
			courVecteur = Probleme.VectProba;
		}
		else
		{
			courVecteur = Probleme.VectSurf;
			//System.out.println("courVecteur[0] = " + courVecteur[0]);
		}
		Taille = (Probleme.Taille)[NumPb];
		this.repaint();
	}
	
	
	
	public void paintComponent (Graphics g)
	{
		//System.out.println("blip");
		//System.out.println(Probleme.Affichage.Onglet);
		//System.out.println("blop");
		
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D)g;
		
		Rectangle2D rect = new Rectangle2D.Double(5,5,5+Largeur,5+Hauteur);
		g2.setColor(Color.black);
		g2.draw(rect);
		
		for (int i = 0 ; i < Taille ; i++)
		{

			
			
			//System.out.println("Problème couleur : " + i + " " + courVecteur[i]);
			g2.setColor(Couleur(courVecteur[i]));
			//System.out.println(courVecteur[0]);
			double xx = courPoints[i][0] * Largeur;
			//System.out.println(xx);
			double yy = courPoints[i][1] * Hauteur;
			Ellipse2D rond = new Ellipse2D.Double(xx - Rayon, yy - Rayon, 2 * Rayon, 2* Rayon);	
			g2.fill(rond);
			g2.setColor(Color.black);
			g2.draw(rond);
			if(!Probleme.ModeProba && Probleme.SiteEnCours == i)
			{
				Line2D Position1 = new Line2D.Double(xx - (Rayon / Math.sqrt(2)), yy - (Rayon / Math.sqrt(2)), xx + (Rayon / Math.sqrt(2)), yy + (Rayon / Math.sqrt(2)));
				g2.draw(Position1);
				Line2D Position2 = new Line2D.Double(xx + (Rayon / Math.sqrt(2)), yy - (Rayon / Math.sqrt(2)), xx - (Rayon / Math.sqrt(2)), yy + (Rayon / Math.sqrt(2)));
				g2.draw(Position2);
			}
			g.drawString(Integer.toString(i+1), (int)(xx)-17, (int)yy + 5);
			

		}
		

		
		
		
		for (int i=0 ; i < Taille ; i++)
		{
			for (int j = 0 ; j < i ; j ++)
			{
				
				
				
				
				if ( Probleme.Liens[NumPb][i][j] || Probleme.Liens[NumPb][j][i] )
				{
					double x1 = Largeur * Probleme.Points[NumPb][j][0];
					double x2 = Largeur * Probleme.Points[NumPb][i][0];
					double y1 = Hauteur * Probleme.Points[NumPb][j][1];
					double y2 = Hauteur * Probleme.Points[NumPb][i][1];
					
					double X = x2 - x1;
					double Y = y2 - y1;
					double N = Math.sqrt(X* X + Y* Y);
					
					double uX = X / N;
					double uY = Y / N;
					
					
					double aX = x1 + Rayon * uX ;
					double aY = y1 + Rayon * uY ;
					double bX = x2 - Rayon * uX ;
					double bY = y2 - Rayon * uY ;
					
					Line2D ligne = new Line2D.Double(aX, aY , bX, bY );
					g2.draw(ligne);
					
					if( Probleme.Liens[NumPb][i][j])
					{
						Line2D lignef1 = new Line2D.Double(bX, bY, bX - Fleche * (uX -   uY), bY - Fleche * (uY + uX) );
						g2.draw(lignef1);
						Line2D lignef2 = new Line2D.Double(bX, bY, bX - Fleche * (uX +   uY), bY - Fleche * (uY - uX) );
						g2.draw(lignef2);
					}
					if( Probleme.Liens[NumPb][j][i])
					{
						Line2D lignef1 = new Line2D.Double(aX, aY, aX + Fleche * (uX -   uY), aY + Fleche * (uY + uX) );
						g2.draw(lignef1);
						Line2D lignef2 = new Line2D.Double(aX, aY, aX + Fleche * (uX +   uY), aY + Fleche * (uY - uX) );
						g2.draw(lignef2);
					}
					
				}
				

				
				
			}
		}
		
		
		
		
		
		
		
	}

	private Color Couleur(double coeff)
	{
		if (Probleme.ModeProba)
		{
			return ColorVerte(coeff);
		}
		else
		{
			return ColorBleue(coeff);
		}
	}
	
	private Color ColorBleue(double coeff)
	{
		double coefflim = 0.7;
		if (coeff > coefflim)
		{
			coeff = coefflim;			
		}

		int rougevert = (int)(255- coeff/coefflim * 255);
		Color C = new Color (rougevert,rougevert,255);
		return C;
			
	}
	
	private Color ColorVerte(double coeff)
	{


		double coefflim = 0.7;
		if (coeff > coefflim)
		{
			coeff = coefflim;			
		}

		int rougevert = (int)(255- coeff/coefflim * 255);
		Color C = new Color (255,rougevert,255);
		return C;
			
	}
	
}
