import javax.swing.*;
import java.awt.*;
import java.text.*;



public class PbReseau
{
	int NbProblemes ;
	int TailleMax ;
	int NumPb;
	
	
	double[][][] Points;
	boolean[][][] Liens;
	double ToutePage;
	//double[][] InitVect;
	double[] VectSurf;
	double[] VectProba;
	int  nbIteration;
	int [] Taille;
	int TailleEnCours;
	double[][] Matrice;
	int[][] nbLiens;
	int SiteEnCours;
	boolean ModeProba;
	
	PannCommandes PaCom;
	PannResultat PaRes;
	PannDessin PaDes;
	PannCompte PaCompte;
	GestionBoutons GesBoutons;
	FenetreGlobale Affichage;
	
	
	public PbReseau(int[] cTaille, boolean[][][] cLiens, double[][][] cPoints)
	{
		NbProblemes = cTaille.length;
		TailleMax = (cPoints[0].length);
		NumPb = 0;
		Taille = cTaille;
		TailleEnCours = Taille[NumPb];
		
		
		SiteEnCours = 0;
		ToutePage = 1;
		Points  = cPoints;
		Liens = cLiens;
		

		nbIteration = 0;

		//InitVect = Normaliser(cInit);
		//CourVect = Normaliser(cVect);
		
		//System.out.println(InitVect[0][0]);
		//CourVect[0][0] = 0;
		//System.out.println(InitVect[0][0]);
		
		ConstruireMatrice();


		GesBoutons = new GestionBoutons(this);
		


		PaCom = new PannCommandes(GesBoutons,this);
		ModeProba = false;
		
		
		
		

		PaRes = new PannResultat(this);
		PaCompte = new PannCompte(this);

		VectProba = new double[TailleEnCours];
		for (int i = 0 ; i < TailleEnCours; i++)
		{
			VectProba[i] = 1.0/TailleEnCours;
		}
		Normaliser(VectProba);
		PaRes.AfficherProba();
		
		
		VectSurf = new double [TailleEnCours];
		VectSurf[SiteEnCours] = 1;
		PaCompte.ReinitialiserCompte();
		
		
		PaDes = new PannDessin(this);

		Affichage  = new FenetreGlobale(this);

		
		
		


	}
	
	public void ConstruireMatrice()
	{
		
		Matrice = new double [TailleEnCours][TailleEnCours];
		int[] nbLiens = new int [TailleEnCours];
		

			
		for (int j = 0 ; j < TailleEnCours ; j++)
		{
			
			nbLiens[j] = 0;   // Compte le nombre de liens pour chaque page.
			for (int i = 0 ; i < TailleEnCours ; i++)
			{
				if (Liens[NumPb][i][j])
				{
					nbLiens[j]++;
				}
			}
			
			if (nbLiens[j]!=0)
			{
				for (int i = 0 ; i < TailleEnCours ; i++) // Construit la matrice de Markov de base
				{
					if (Liens[NumPb][i][j])
					{		
						Matrice[i][j] = 1.0/nbLiens[j];
					}
				}	
			}
			else 
			{
				for (int i = 0 ; i < TailleEnCours ; i++)
				{
					if (j!= i)
					{
						Matrice[i][j] = 1.0 / TailleEnCours;				
					}

				}
			}
		}
		
		if (true)
		{
			for (int i = 0 ; i < TailleEnCours ; i++)
			{
				for (int j = 0 ; j < TailleEnCours ; j++)
				{
					Matrice[i][j] = (ToutePage) * Matrice[i][j] + (1-ToutePage) / TailleEnCours ;
				}
			}

		

		
		
		}
		

		
	}
	

	
	
	public void Reinitialiser(int Num, double coeff)
	{
		//ModeProba = PaCom.ModeProba;
		//System.out.println(ModeProba);
		//Affichage.Blop();
		//Affichage.MettreAJour(ModeProba);
		nbIteration = 0;
		PaCom.AfficherNbIterations();
		NumPb = Num;
		TailleEnCours = Taille[Num];
		ToutePage = coeff;
		
		ReinitialiserProba();
		ReinitialiserSurf();

		PaDes.Rafraichir();
	}
	
	public void ReinitialiserProba()
	{
		VectProba = new double[TailleEnCours];

		for (int i = 0 ; i < TailleEnCours; i++)
		{
			VectProba[i] = Double.parseDouble( PaRes.InitDonnees[i].getText());
		}
		Normaliser(VectProba);

		
		ConstruireMatrice();

		
		PaRes.ReinitialiserPaRes();
		PaRes.AfficherProba();
	}
	
	
	public void ReinitialiserSurf()
	{
		VectSurf = new double[TailleEnCours];
		if (SiteEnCours >= TailleEnCours)
		{
			SiteEnCours = 0;
		}
		PaCompte.ReinitialiserCompte();
		for (int i = 0 ; i < TailleEnCours ; i++)
		{
			//System.out.println(i);
			VectSurf[i] = (Double.parseDouble(PaCompte.Frequence[i].getText()))/100;
		}	
		for (int i = 0 ; i < TailleEnCours ; i++)
		{
			VectSurf[i] = (Double.parseDouble(PaCompte.Frequence[i].getText()))/100;
		}
	}

	

	public void Iterer()
	{

		nbIteration ++;
		//System.out.println(Boolean.toString(ModeProba));

		ItererProba();	

		ItererSurf();

		PaDes.repaint();
		PaCom.AfficherNbIterations();

		
	}
	
	
	
	public void ItererSurf()
	{
		//System.out.println("Méthode ItererSurf, site en cours : " + SiteEnCours);
		if(Math.random()<ToutePage)
		{
			int NbLien = 0;
			int [] DirPoss = new int[TailleEnCours];
			for (int i = 0 ; i < TailleEnCours ; i++)
			{
				if (Liens[NumPb][i][SiteEnCours])
				{
					DirPoss[NbLien] = i;
					NbLien++;
				}
			}
			SiteEnCours = DirPoss [(int) (Math.random() * NbLien)];
		}
		else
		{
			SiteEnCours = (int) (Math.random()*TailleEnCours);
		}
		PaCompte.Ajuster(SiteEnCours);
		//System.out.println("Méthode ItererSurf, site en cours : " + SiteEnCours);
		
		for (int i = 0 ; i < TailleEnCours ; i++)
		{
			VectSurf[i] = (Double.parseDouble(PaCompte.Frequence[i].getText()))/100;
		}
		
			
		PaDes.repaint();
	}
	
	
	
	public void ItererProba()
	{
		int num = NumPb;
		//System.out.println("NumPb : " + NumPb + Taille[num]);
		double[] Temp = new double[TailleEnCours];
		for (int i = 0; i < Taille[num] ; i++)
		{
			Temp[i]  = 0;
			for (int j = 0 ; j < Taille[num] ; j++)
			{
				Temp[i] += Matrice[i][j] * VectProba[j]; 
				//System.out.println("Matrice (" + i + "," + j + ") : " + Matrice[i][j] +"  "+ Temp[j]);
			}
		}
		for (int i = 0 ; i < Taille[num] ; i++)
		{
			VectProba[i] = Temp[i];
		}
		
		

	}
	
	
	/*
	public double getPointsX(int i)
	{
		return Points[i][0];
	}
	
	public double getPointsY(int i)
	{
		return Points[i][1];
	}

	public double[][] getPointsTous()
	{
		return Points;
	}
	
	public double[] getCourVect()
	{
		return CourVect;
	}
	
	public int getTaille()
	{
		return Taille;
	}
	
	public PannCommandes getPaCom()
	{
		return PaCom;
	}
	
	public PannDessin getPaDes()
	{
		return PaDes;
	}
	
	public PannResultat getPaRes()
	{
		return PaRes;
	}
	public GestionBoutons getGesBoutons()
	{
		return GesBoutons;
	}
	*/
	
	
	
	public double[] Normaliser(double[] Vect)
	{
		int TailleV = Vect.length;
		double norme  =   Norme1(Vect);
		if (norme != 0)
		{
			for(int i = 0 ; i < TailleV ; i++)
			{
				Vect[i] = Vect[i] / norme 	;	
			}	
		}
		else
		{
			for(int i = 0 ; i < TailleV ; i++)
			{
				Vect[i] = 1/TailleV	;	
			}

		}
		return Vect;
	}
	
	
	public double Norme1(double[] Vecteur)
	{
		int Taille = Vecteur.length;
		double nn = 0;
		for(int i = 0 ; i < Taille ; i++)
		{
			nn += Math.abs(Vecteur[i]);
		}
		return  nn;
	}
	
}
